@echo off

	set _ftpaddress=%1
	set _ftpusername=%2
	set _ftppassword=%3
	set _localfolder=%~f4
	set _remotefolder=%5
	set _delete=%6

	set _errormessage=
	
	if "%~1"=="" (
  		goto HELP
	)

	if "%_ftpaddress%" == "" (
		set _errormessage= FTP address is missing.
		goto ERROR
	)
	if "%_ftpusername%" == "" (
		set _errormessage= FTP user name is missing.
		goto ERROR
	)
	if "%_ftppassword%" == "" (
		set _errormessage= FTP password is missing.
		goto ERROR
	)
	if "%_localfolder%" == "" (
		set _errormessage= Source directory is missing.
		goto ERROR
	)
	if "%_remotefolder%" == "" (
		set _errormessage= Destination directory is missing.
		goto ERROR
	)
	
	if not "%6" == "" (
		if not "%6" == "/delete" (
			set _errormessage= Unknown option.
			goto ERROR
		) else (
			set _delete=-delete
		)
	)
goto RUN

:RUN
	WinSCP.com /command "option batch abort" "option confirm off" "option reconnecttime 60" "open ftp://%_ftpusername%:%_ftppassword%@%_ftpaddress%/" "lcd %_localfolder%" "cd %_remotefolder%" "synchronize remote %_delete%" "exit"
goto EXIT

:ERROR
	echo.
	<nul >" ########## " set /p "=-%bs%%bs%%bs%%bs%"
	<nul >" # Error  # " set /p "=-%bs%%bs%%bs%%bs%"
	findstr /a:0C . "*###*"
	echo.
	findstr /a:0C . "*error*"
	echo %_errormessage%
	findstr /a:0C . "*###*"
	del " ########## "
	del " # Error  # "
	echo.
	set _errormessage=
goto HELP

:HELP
echo.
echo  ##############################################################################
echo  # MIRROR UPLOAD (version 1.0)                              [www.TechTalk.cc] #
echo  # Uploads files and directories (and overwrites) to destination with WinSCP. #
echo  ##############################################################################
echo. #                                                                            #
echo  # Obligatory parameters                                                      #
echo. #                                                                            #
echo  #          ip : ftp IP or address (127.0.0.1 or ftp.domain).                 #
echo  #    username : ftp user name (janedoe).                                     #
echo  #    password : ftp user password (p4ssw0rd).                                #
echo  #      source : full path of the local source directory (drive:\path\).      #
echo  # destination : remote destination directory (/root/janedoe/).               #
echo. #                                                                            #
echo  # Optional parameters                                                        #
echo. #                                                                            #
echo  #     /delete : deletes files and folders in destination if not in source.   #
echo. #                                                                            #
echo  ##############################################################################
goto EXIT

:EXIT
	set _ftpaddress=
	set _ftpusername=
	set _ftppassword=
	set _localfolder=
	set _remotefolder=
	set _delete=
	set _errormessage=

@echo on